// Camera.h: Schnittstelle fr die Klasse Camera.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CAMERA_H__A21EB7D3_8C9E_4262_BA22_72FA6D6F4350__INCLUDED_)
#define AFX_CAMERA_H__A21EB7D3_8C9E_4262_BA22_72FA6D6F4350__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "d3drenderlayer.h"
#include "math.h"


const enum { FI_INSIDE, FI_OUTSIDE, FI_INTERSECT };


class Camera  
{
public:
	D3DXVECTOR3 GetPos();
	void SetPos(D3DXVECTOR3 & _pos);
	void SetTransformLookAt(D3DXVECTOR3& _at);
	int FrustrumIntersect(AABB * _bb);
	void SetProjectionTransform();
	void SetTransform();	

	void Move(int _axis, float _dist);
	void Yaw(float _alpha);
	void Pitch(float _alpha);

	D3DXMATRIX m_matView;
	D3DXMATRIX m_matProjection;

	D3DXVECTOR3 m_vPos;
	float m_fAngleX;	// viewing angle pitch
	float m_fAngleY;	// viewing angle yaw

	float m_fFov;

	Camera();

	Plane m_FrustrumPlane[6];	// near,far,left,right,top,bottom


	float m_fClipNear;
	float m_fClipFar;
	float m_fAspectWidth;	//volume width / dist
	float m_fAspectHeight;	// volume height / dist

	float m_fMoveSpeed;
	float m_fCameraRadius;


private:
	void SetFrustrumPlanes();
};

#endif // !defined(AFX_CAMERA_H__A21EB7D3_8C9E_4262_BA22_72FA6D6F4350__INCLUDED_)
