// D3DRenderLayer.h: Schnittstelle fr die Klasse D3DRenderLayer.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_D3DRENDERLAYER_H__EAE8ADC0_F4AB_11D5_ADB1_0020E061A328__INCLUDED_)
#define AFX_D3DRENDERLAYER_H__EAE8ADC0_F4AB_11D5_ADB1_0020E061A328__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "d3dlayer.h"


typedef int handleTex;
typedef int handleVB;
typedef int handleIB;



#define g_pD3DRenderLayer (D3DRenderLayer::GetSingleton())
class D3DRenderLayer : public Singleton<D3DRenderLayer> 
{
public:
	HRESULT UnlockRect(handleTex _tex, UINT _level);
	HRESULT LockRect(handleTex _tex, UINT _level, D3DLOCKED_RECT* _lockedRect, CONST RECT* _rect, DWORD _flags);
	HRESULT GetViewport(D3DVIEWPORT8 * _viewport);
	handleTex CreateTexture( const char* _filename, UINT _width, UINT _height, UINT _miplevels, DWORD _usage,
							 D3DFORMAT _format, D3DPOOL _pool, DWORD _filter, DWORD _mipfilter, 
							 D3DCOLOR _colorkey, D3DXIMAGE_INFO* _srcInfo, PALETTEENTRY* _palette);
	HRESULT ApplyStateBlock(DWORD _token);
	HRESULT DeleteStateBlock(DWORD _token);
	HRESULT EndStateBlock(DWORD * _token);
	HRESULT BeginStateBlock();
	HRESULT SetTextureStageState(DWORD _stage,D3DTEXTURESTAGESTATETYPE _type, DWORD _value);
	HRESULT SetRenderState(D3DRENDERSTATETYPE _type, DWORD _state);
	void FillIB(handleIB _buffer, const WORD *_data, int _datasize);
	handleIB CreateIndexBuffer(UINT _length, DWORD _usage);
	handleVB CreateVertexBuffer(UINT _buffersize, size_t _vertexsize, DWORD _usage, DWORD _fvf);
    HRESULT SetMaterial(CONST D3DMATERIAL8* _material);
    HRESULT SetTransform(D3DTRANSFORMSTATETYPE _state, CONST D3DMATRIX* _matrix);
    HRESULT Clear(D3DCOLOR _color=D3DCOLOR_XRGB(0,0,255), float _z = 1.0f);
    HRESULT EndScene();
    HRESULT BeginScene();
    HRESULT Present();
	D3DRenderLayer(D3DLayer * _d3dLayer);
	virtual ~D3DRenderLayer();
    handleTex CreateTexture(const char * _filename);
    HRESULT SetTexture(DWORD _stage, handleTex _tex);
	HRESULT LockVB(handleVB _buffer, UINT _offset, UINT _size, BYTE** _data, DWORD _flags);
	void FillVB(handleVB _buffer, BYTE *_data, int _numVertices, size_t _vertexsize, int offset=0);
    HRESULT UnlockVB(handleVB _buffer);
    HRESULT SetStreamSource(UINT _number,handleVB _data, UINT _stride);
    HRESULT SetVertexShader(DWORD _handle);
    HRESULT DrawPrimitive(D3DPRIMITIVETYPE _type, UINT _start, UINT _count);
    HRESULT DrawIndexedPrimitive(D3DPRIMITIVETYPE _type, UINT _minindex, UINT _numvertices, UINT _startindex, UINT _count);
    HRESULT SetIndices(handleIB _buffer, UINT _baseindex);


private:
	void SetInitialRenderStates();
	LPDIRECT3DDEVICE8 m_pd3dDevice;

    std::vector<LPDIRECT3DVERTEXBUFFER8> m_vpVB;
    std::vector<LPDIRECT3DINDEXBUFFER8>  m_vpIB;
    std::vector<LPDIRECT3DTEXTURE8>      m_vpTexture;
};


#endif // !defined(AFX_D3DRENDERLAYER_H__EAE8ADC0_F4AB_11D5_ADB1_0020E061A328__INCLUDED_)
