// Energy.h: Schnittstelle fr die Klasse Energy.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENERGY_H__2F0D9B0F_2939_4B7B_9938_D5C3972F714D__INCLUDED_)
#define AFX_ENERGY_H__2F0D9B0F_2939_4B7B_9938_D5C3972F714D__INCLUDED_

#include "D3DRenderLayer.h"	// Hinzugefgt von der Klassenansicht
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "math.h"
#include "DSoundLayer.h"	// Hinzugefgt von der Klassenansicht

#define D3DFVF_ENERGYVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1|D3DFVF_TEXCOORDSIZE2(0))
struct ENERGYVERTEX
{
    D3DXVECTOR3 pos;
    DWORD c;
	float u, v;
};

struct Ripple
{
	D3DXVECTOR3 m_vPos;
	float m_fLife;
	D3DXVECTOR3 m_pTransQuadVertex[4];
	float m_fMaxRadius;
};

#define g_pEnergy Energy::GetSingleton()
class Energy : public Singleton<Energy>
{
public:
	void Render();
	void FrameMove();
	void Create(D3DXVECTOR3 & _pos, D3DXVECTOR3 & _n, D3DXVECTOR3 &_up, float _force);
	Energy();
	virtual ~Energy();

private:
	handleSound m_hSound;
	ENERGYVERTEX m_vertQuad[4];
	handleTex m_hTex;
	handleVB m_hVB;
	Ripple m_pRipple[4];
	int m_iNextRipple;
};

#endif // !defined(AFX_ENERGY_H__2F0D9B0F_2939_4B7B_9938_D5C3972F714D__INCLUDED_)
