// Game.h: Schnittstelle fr die Klasse Game.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAME_H__24C2CEEC_B9BA_11D5_ADB1_0020E061A328__INCLUDED_)
#define AFX_GAME_H__24C2CEEC_B9BA_11D5_ADB1_0020E061A328__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "globalsextern.h"

#include "ParticleSystem.h"
#include "D3DFont.h"
#include "d3dlayer.h"
#include "d3drenderlayer.h"
#include "terrain.h"
#include "Camera.h"	
#include "Sphere.h"
#include "DSoundLayer.h"


class Sphere;
class Terrain;
class ParticleSystem;



#define D3DFVF_SHADOWQUADVERTEX (D3DFVF_XYZRHW |D3DFVF_DIFFUSE | D3DFVF_SPECULAR  )
struct SHADOWQUADVERTEX
{
	D3DXVECTOR4 pos;
	DWORD color;
	DWORD specular; 
};

#define g_pGame Game::GetSingleton()
class Game:public Singleton<Game>  
{
public:
	float GetAmbient();
	D3DXVECTOR3 GetLightDir();
	float GetGravity();
	int GetTargetFPS();
	void TogglePause();
	void Explode();
	Camera GetCamera();
	void ToggleFollow();
	Terrain* GetTerrain();
	void Pitch(float _alpha);
	void Yaw(float _alpha);
	void Move(int _axis, int _dir);
	void FrameMove(int _ticks);
	void Render();
	Game();
	virtual ~Game();

private:
	char m_szFPS[16];
	LARGE_INTEGER m_liTicksPerSecond;
	float m_fExplosionStrength;
	int m_iNumExplosionParticles;
	long m_iTicksSinceLastExplode;
	void MoveCamera();
	int m_iInvertMouse;
	int m_iMoving[3];
	int m_iMouseSensitivity;
	int m_iMoveSpeed;
	float m_fAmbient;
	D3DXVECTOR3 m_vLightDir;
	int m_iTargetFPS;
	float m_fGravity;
	handleEffect m_hEffSmoke;
	handleEffect m_hEffExplosion1;
	handleEffect m_hEffExplosion2;
	bool m_bPaused;
	handleSound m_hSoundExplode;
	D3DXVECTOR3 m_vFreeCameraPos;
	bool m_bFollow;
	handleVB m_hVBShadowQuad;
	void RenderShadow();
	Sphere* m_pSphere;
	Camera m_Camera;
	Terrain* m_pTerrain;
	void InitGeometry();
};

#endif // !defined(AFX_GAME_H__24C2CEEC_B9BA_11D5_ADB1_0020E061A328__INCLUDED_)
