// Math.h: Schnittstelle fr die Klasse Math.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MATH_H__6B34F070_E706_4BC2_8799_86EE5742DF6A__INCLUDED_)
#define AFX_MATH_H__6B34F070_E706_4BC2_8799_86EE5742DF6A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct AABB
{
	float minX, maxX;
	float minY, maxY;
	float minZ, maxZ;
};

struct Plane
{
	float a,b,c,d;	// ax + by + cz + d = 0
};

class Math  
{
public:
	inline static int ColorScale(int _color, float _f)
	{
		return ((int)(((_color & 0xff000000) >> 24)*(_f>1.0f?1.0f:_f)) << 24) +
			   ((int)(((_color & 0x00ff0000) >> 16)*(_f>1.0f?1.0f:_f)) << 16) +
			   ((int)(((_color & 0x0000ff00) >>  8)*(_f>1.0f?1.0f:_f)) <<  8) +
			   ((int)(((_color & 0x000000ff)      )*(_f>1.0f?1.0f:_f))      );
	}
	inline static float absf(float _f)
	{
		return _f<0?-_f:_f;
	}
	inline static float maxf(float _f1, float _f2)
	{
		return _f1>_f2?_f1:_f2;
	}
	inline static float minf(float _f1, float _f2)
	{
		return _f1<_f2?_f1:_f2;
	}
	inline static int ld(int _i)
	{
		int ret = 0;
		while (_i >>=1) ret++;
		return ret;
	}

	inline static float GetMax(float _x1, float _x2, float _x3, float _x4)
	{
		if (_x2>_x1) _x1 = _x2;
		if (_x3>_x1) _x1 = _x3;
		if (_x4>_x1) _x1 = _x4;
		return _x1;
	}

	inline static float GetMin(float _x1, float _x2, float _x3, float _x4)
	{
		if (_x2<_x1) _x1 = _x2;
		if (_x3<_x1) _x1 = _x3;
		if (_x4<_x1) _x1 = _x4;
		return _x1;
	}

	inline static void GetMinMax(float _x1, float _x2, float _x3, float _x4, float* _min, float* _max)
	{
		if (_x1 > _x2)
		{
			*_max = _x1;
			*_min = _x2;
		}
		else
		{
			*_max = _x2;
			*_min = _x1;
		}
		if (_x3 > _x4)
		{
			if (_x3>*_max) *_max = _x3;
			if (_x4<*_min) *_min = _x4;
		} 
		else
		{
			if (_x4>*_max) *_max = _x4;
			if (_x3<*_min) *_min = _x3;
		}
	}

private:
	Math();
};

#endif // !defined(AFX_MATH_H__6B34F070_E706_4BC2_8799_86EE5742DF6A__INCLUDED_)
