// Mesh.cpp: Implementierung der Klasse Mesh.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Mesh.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

handleVB				Mesh::m_hVB			  = -1;
int                     Mesh::m_iFVFSize      = 0;
DWORD					Mesh::m_dwFVF         = 0;
int                     Mesh::m_iNumInstances = 0;

Mesh::Mesh(const void*pVertices, int iNumVertices, const WORD*pIndices, int iNumIndices, int iOffset)
{
    assert(m_hVB != -1);
    assert(m_iFVFSize );

    assert(iNumIndices % 3 == 0 )

    m_iNumInstances++;

    m_iNumTriangles = iNumIndices / 3;
    m_iNumVertices = iNumVertices;

    m_iOffset = iOffset;

    //write vertices to buffer
	g_pD3DRenderLayer->FillVB(m_hVB, (BYTE*)pVertices, iNumVertices, m_iFVFSize, m_iOffset);
    
    //create index buffer
	m_hIB = g_pD3DRenderLayer->CreateIndexBuffer(iNumIndices, D3DUSAGE_WRITEONLY);

    //write indices to buffer
	g_pD3DRenderLayer->FillIB(m_hIB, pIndices, iNumIndices);

}

Mesh::~Mesh()
{
}

void Mesh::Render()
{   

	g_pD3DRenderLayer->SetVertexShader(m_dwFVF);
    g_pD3DRenderLayer->SetStreamSource( 0, m_hVB, m_iFVFSize);
    g_pD3DRenderLayer->SetIndices(m_hIB, 0);


    g_pD3DRenderLayer->DrawIndexedPrimitive( D3DPT_TRIANGLELIST, m_iOffset, m_iNumVertices, 0, m_iNumTriangles );   
}


void Mesh::SetVB(handleVB _VB)
{
    m_hVB = _VB;
}

void Mesh::SetFVF(DWORD dwFVF, int iSize)
{
    m_iFVFSize = iSize;
	m_dwFVF = dwFVF;
}

