// Mesh.h: Schnittstelle fr die Klasse Mesh.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MESH_H__7BCDB103_D616_11D5_ADB1_0020E061A328__INCLUDED_)
#define AFX_MESH_H__7BCDB103_D616_11D5_ADB1_0020E061A328__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "globalsextern.h"
#include "d3drenderlayer.h"

class Mesh  
{
    friend class MeshManager;
public:
	void Render();
	virtual ~Mesh();

private:
	Mesh(const void*pVertices, int iNumVertices, 
		const WORD*pIndices, int iNumIndices, int iOffset); // only allow friend MeshManager to create instances
	int m_iOffset;
	int m_iNumTriangles;
    int m_iNumVertices;
	int m_iMinIndex;
	handleIB m_hIB;	// handle to own IB


	static void SetFVF(DWORD dwFVF, int iSize);
	static void SetVB(handleVB _VB);

    static int m_iFVFSize;
	static DWORD m_dwFVF;
	static int m_iNumInstances;
	static handleVB m_hVB;	// handle to VB used by all meshes
};

#endif // !defined(AFX_MESH_H__7BCDB103_D616_11D5_ADB1_0020E061A328__INCLUDED_)
