// MeshManager.h: Schnittstelle fr die Klasse MeshManager.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MESHMANAGER_H__DB0BAAA3_D99F_11D5_ADB1_0020E061A328__INCLUDED_)
#define AFX_MESHMANAGER_H__DB0BAAA3_D99F_11D5_ADB1_0020E061A328__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "globalsextern.h"
#include "Mesh.h"
#include "meshfactory.h"

#define D3DFVF_OBJECTVERTEX (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_TEX1| \
							  D3DFVF_TEXCOORDSIZE2(0))
struct OBJECTVERTEX
{
    D3DXVECTOR3 pos;
	D3DXVECTOR3 n;
    float tu1, tv1;
};


#define g_pMeshManager MeshManager::GetSingleton()
class MeshManager : public Singleton<MeshManager>
{
public:
	Mesh* CreateMesh(const std::vector<MESHFACTORYVERTEX>&vVertex, const std::vector<WORD>&vIndex);
	Mesh* CreateMesh(const OBJECTVERTEX*pVertices, int iNumVertices, const WORD*pIndices, int iNumIndices);
	Mesh* GetMesh(int m);
	MeshManager();
	virtual ~MeshManager();

private:
	int m_iNumMeshes;
	handleVB m_hVB;
    std::vector<Mesh*> m_pMesh;
	unsigned int m_iNumTotalVertices;
};

#endif // !defined(AFX_MESHMANAGER_H__DB0BAAA3_D99F_11D5_ADB1_0020E061A328__INCLUDED_)
