// Model.h: Schnittstelle fr die Klasse Model.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MODEL_H__DB0BAAA4_D99F_11D5_ADB1_0020E061A328__INCLUDED_)
#define AFX_MODEL_H__DB0BAAA4_D99F_11D5_ADB1_0020E061A328__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "globalsextern.h"
#include "mesh.h"
#include "object.h"
#include "d3drenderlayer.h"

class Object;

class Model  
{
public:
	Model* GetChild(int iChild);

	const D3DXMATRIX&GetChildMatrix(int iChild);
	const D3DXMATRIX&GetMeshMatrix(int m);

	int GetNumMeshes();
	int GetNumChildren();

	void AddChild(Model*pChild, const D3DXMATRIX &matChild);
	void AddMesh(Mesh *pMesh, const handleTex _hTex, const D3DMATERIAL8 &mat, const D3DXMATRIX& matMesh);

	void Render(const D3DXMATRIX &matWorld);

	Object* GetInstance();

	Model();
	virtual ~Model();
private:
    int m_iNumMeshes;
	int m_iNumChildren;

    std::vector<Mesh*> m_vpMesh;
    std::vector<handleTex> m_vhTexture;
    std::vector<D3DMATERIAL8> m_vMaterial;
    std::vector<D3DXMATRIX> m_vmatMesh;       //puts every mesh at its position

    std::vector<Model*> m_vpChild;
    std::vector<D3DXMATRIX> m_vmatChild;

};

#endif // !defined(AFX_MODEL_H__DB0BAAA4_D99F_11D5_ADB1_0020E061A328__INCLUDED_)
