// Object.h: Schnittstelle fr die Klasse Object.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OBJECT_H__DB0BAAA5_D99F_11D5_ADB1_0020E061A328__INCLUDED_)
#define AFX_OBJECT_H__DB0BAAA5_D99F_11D5_ADB1_0020E061A328__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "globalsextern.h"
#include "Model.h"

class Model;

class Object  
{
public:
	Object* GetChild(int iChild);

	const D3DMATRIX&GetCompositeMatrix();
	const D3DXMATRIX&GetWorldMatrix();

	void SetWorldMatrix(const D3DXMATRIX&matWorld);

	void Render(const D3DXMATRIX&matParent);
	void Render();

	Object(Model*pModel);
	virtual ~Object();

private:
	D3DXMATRIX m_matComposite;  // world matrix transformed by parent's world matrix
	D3DXMATRIX m_matWorld;  // world matrix of this object, not taking into account transformations through parents

	Model* m_pModel;

    std::vector<Object*> m_vpChild;
    std::vector<D3DXMATRIX> m_vmatChild;
};

#endif // !defined(AFX_OBJECT_H__DB0BAAA5_D99F_11D5_ADB1_0020E061A328__INCLUDED_)
