// Parameters.h: Schnittstelle fr die Klasse Parameters.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARAMETERS_H__6DD8ECEC_899B_4DA0_B3A3_671C8323B71B__INCLUDED_)
#define AFX_PARAMETERS_H__6DD8ECEC_899B_4DA0_B3A3_671C8323B71B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Utils.h"
#include <fstream.h>

#pragma warning( disable : 4786 ) // too long identifiers


struct File
{
	std::string name;
	std::map<std::string, std::string> mapParams;
};


#define SETPARAMETERFILE(_name) (Parameters::GetSingleton()->SetFile(_name))
#define LOADINT(_name, _default) (Parameters::GetSingleton()->LoadParameterInt(_name, _default))
#define LOADFLOAT(_name, _default) (Parameters::GetSingleton()->LoadParameterFloat(_name, _default))
#define LOADSTRING(_name, _default) (Parameters::GetSingleton()->LoadParameterString(_name, _default))
//#define LOADINT(_name, _default) _default
//#define LOADFLOAT(_name, _default) _default
//#define LOADSTRING(_name, _default) (std::string(_default))


#define g_pParameters Parameters::GetSingleton()
class Parameters : public Singleton<Parameters>
{
public:
	void SetFile(std::string _name);
	int LoadParameterInt(std::string _name, int _default = 0);
	float LoadParameterFloat(std::string _name, float _default = 0.0f);
	std::string LoadParameterString(std::string _name, std::string _default = "");
	
	Parameters();
	virtual ~Parameters();

private:
	const char * GetParameter(File * _file, std::string _name);
	bool LoadFile(std::string _name);
	void Trim(std::string * _string);
	File* GetFile(std::string _name);
	std::vector<File> m_vFile;
	File * m_pCurFile;
};

#endif // !defined(AFX_PARAMETERS_H__6DD8ECEC_899B_4DA0_B3A3_671C8323B71B__INCLUDED_)
