// Params.h: Schnittstelle fr die Klasse Params.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARAMS_H__EAE8ADC1_F4AB_11D5_ADB1_0020E061A328__INCLUDED_)
#define AFX_PARAMS_H__EAE8ADC1_F4AB_11D5_ADB1_0020E061A328__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <fstream.h>

template <typename T> class Params  
{
public:

	Params()
	{
		ms_pStringTable = std::list<char*>(0);
	}

	virtual ~Params()
	{
		std::list<char*>::iterator it = ms_pStringTable.begin();
		while (it != ms_pStringTable.end())
		{
			delete [] *it++;
		}
	}

	void ReadParams(char*_filename)
    {
       ifstream in(_filename);
       if (in.fail())
        {
            std::string msg = "Failed to open parameterfile ";
            msg += _filename;
            msg += ". Using default parameters";
            g_pUtils->Log(msg);
            return;
        }

        std::string line;
        std::string datatype;
        std::string value;
        size_t structureSize = sizeof(T);
        int numLine = 0;
		int offset = sizeof(void*);	// hack : accounts for vfptr
		T * p = (T*) this;

        while (!in.eof())
        {
            numLine++;
            try
            {
                std::getline(in, line);
                if (line.c_str()[0] == '#' || line == "") continue;

                datatype = line.substr(0, line.find(" "));

                value = line.substr(line.find("=")+1, line.length()-line.find("=")-1);

                if (isspace(value.c_str()[0]))
                    value = value.substr(1, value.length()-1);
                else
                    value = value.substr(0, value.length());
            }
            catch (...)
            {
                std::string msg = "Parse error in file ";
                msg += _filename;
                msg += ". Using default parameters";
                g_pUtils->Log(msg);
                return;
            }

            if (datatype == "int")
            {
				// handle hexadecimal numbers
				if(value[0] == '0' && tolower(value[1]) == 'x')
				{
					int iValue = 0;
					char ch[2];
					ch[1] = '\0';
					for (unsigned int pos = 2; pos<value.length(); pos++)
					{
						*ch = tolower(value[pos]);
						if (isalpha(*ch))
						{
							iValue += (10 + (*ch - 'a')) * (int)pow(16, value.length() - pos - 1);
						}
						else iValue += atoi(ch) * (int)pow(16, value.length() - pos - 1);
					}
					*(int*)((char*)this + offset) = iValue;
				}
				else
					// decimal numbers
					*(int*)((char*)this + offset) = atoi(value.c_str());

                offset += sizeof(int);
            }
            else if (datatype == "float")
            {
                *(float*)((char*)this + offset) = (float)atof(value.c_str());
                offset += sizeof(float);
            }
			else if (datatype == "string")
			{
				char * pString = new char[value.size()+1];
				strcpy(pString, value.c_str());
				ms_pStringTable.push_back(pString);

				char ** ppChar = (char**)((char*)this + offset);

				//if (*ppChar != NULL) delete  *ppChar;

				*ppChar = pString;

				offset += sizeof(char*);
			}
            else
            {
                std::string msg = "Unknown datatype ";
                msg += datatype + " encountered in file ";
                msg += _filename;
                msg += ". Using default parameters.";
                g_pUtils->Log(msg);
                return;
            }
        }
		in.close();
   }
	static std::list<char*> ms_pStringTable;
private:
};

template <typename T> std::list<char*> Params<T>::ms_pStringTable;

#endif // !defined(AFX_PARAMS_H__EAE8ADC1_F4AB_11D5_ADB1_0020E061A328__INCLUDED_)
