// Profiler.h: Schnittstelle fr die Klasse Profiler.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROFILER_H__C4827DB1_A5F1_4386_BB6E_289DBF1A4803__INCLUDED_)
#define AFX_PROFILER_H__C4827DB1_A5F1_4386_BB6E_289DBF1A4803__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define NUM_PROFILE_SAMPLES 30

#define PROFILESTART(str) Profiler::GetSingleton()->ProfileStart(str)
#define PROFILESTOP(str) Profiler::GetSingleton()->ProfileStop(str)

struct ProfileSample {
   bool bValid;                 //Whether this data is valid
   unsigned int iProfileInstances;      //# of times ProfileBegin called
   int iOpenProfiles;           //# of times ProfileBegin w/o ProfileEnd
   char szName[256];            //Name of sample
   LARGE_INTEGER liStartTime;            //The current open profile start time
   LARGE_INTEGER liAccumulator;          //All samples this frame added together
   LARGE_INTEGER liChildrenSampleTime;   //Time taken by all children
   unsigned int iNumParents;            //Number of profile parents
};

struct ProfileSampleHistory{
   bool bValid;        //Whether the data is valid
   char szName[256];   //Name of the sample
   float fAve;         //Average time per frame (percentage)
   float fMin;         //Minimum time per frame (percentage)
   float fMax;         //Maximum time per frame (percentage)
};


#define g_pProfiler Profiler::GetSingleton()
class Profiler : public Singleton<Profiler> 
{
public:
	int GetFrameTime();
	void DumpToBuffer();
	void ProfileStop(char* _name);
	void ProfileStart(char*name);
	Profiler();
	std::string m_strBuffer;

private:
	void GetProfileFromHistory(char* _name, float* _ave, float* _min, float* _max);
	LARGE_INTEGER m_liFrameTime;
	void StoreProfileInHistory(char* _name, float _percent);

	LARGE_INTEGER m_liProfileStart;
	LARGE_INTEGER m_liProfileStop;
	float m_fTicksPerSecond;

	ProfileSample m_Sample[NUM_PROFILE_SAMPLES];
	ProfileSampleHistory m_History[NUM_PROFILE_SAMPLES];

};

#endif // !defined(AFX_PROFILER_H__C4827DB1_A5F1_4386_BB6E_289DBF1A4803__INCLUDED_)
