
#include "globalsextern.h"

template <typename T> class Singleton
{
    static T* ms_pSingleton;

public:
    Singleton()
    {
        assert( !ms_pSingleton ); // make sure class hasn't been instantiated yet
        int offset = (int)(T*)1 - (int)(Singleton <T>*)(T*)1; // calc offset to child class
        ms_pSingleton = (T*)((int)this + offset); // store pointer to child class
    }
    ~Singleton()
    {
        assert( ms_pSingleton ); // make sure class has been instantiated
        ms_pSingleton = NULL;
    }

    static T* GetSingleton()
    {
    //    assert(ms_pSingleton);
        return ms_pSingleton;
    }
};

template <typename T> T* Singleton <T>::ms_pSingleton = NULL;