// Sphere.h: Schnittstelle fr die Klasse Sphere.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPHERE_H__8854C59D_D214_45AF_B5A8_858ABE063FAF__INCLUDED_)
#define AFX_SPHERE_H__8854C59D_D214_45AF_B5A8_858ABE063FAF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "DSoundLayer.h"	
#include "meshfactory.h"
#include "meshmanager.h"
#include "ParticleSystem.h"	
#include "game.h"
#include "D3DRenderLayer.h"
#include "ShadowVolume.h"
#include "energy.h"

#define SPHEREPARAMSFILE "sphereparams.txt"

class Game;



class Sphere  
{
public:
	void SetSoundPosition();
	void SetVelocity(D3DXVECTOR3 _vel);
	float GetRadius();
	bool HasStopped();
	D3DXVECTOR3 GetVelocity();
	void RenderShadow();
	D3DXVECTOR3 GetPos();
	void FrameMove();
	void Render();
	Sphere();
	virtual ~Sphere();

private:
	handleTex m_hTex;
	Mesh* m_pMesh;
	handleEffect m_hEffDust;
	void PlayBounceSound(float speed, bool _rolling);
	handleSound m_hBounceSound;
	handleSound m_hRollSound;
	void CreateShadowVolume();
	static ShadowVolume * ms_pSV;
	bool m_bStopped;
	D3DXMATRIX m_matRot;
	D3DXMATRIX m_matPrevRot;
	float m_fRotSpeed;
	float m_fRotAngle;
	D3DXVECTOR3 m_vRotAxis;
	D3DXVECTOR3 m_pVecOffset[17];	// vector center-point to appr. collision
	D3DXVECTOR3 m_vSpeed;
	static int ms_iNumInstances;
	D3DXVECTOR3 m_vPos;
	float m_fRadius;

	float m_fBounciness;
	float m_fDrag;
	float m_fRollDrag;
	float m_fRotateDrag;

	float m_fRollThreshold;
	float m_fStopThreshold;

};

#endif // !defined(AFX_SPHERE_H__8854C59D_D214_45AF_B5A8_858ABE063FAF__INCLUDED_)
