// Utils.cpp: Implementierung der Klasse Utils.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Utils.h"


//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////


void Utils::LogOpen()
{
#ifdef _DEBUG
    m_pfileLog = fopen( LOGFILENAME, "a");
#else
    m_pfileLog = fopen( LOGFILENAME, "w");
#endif

    SYSTEMTIME time;
    GetLocalTime(&time);

    Log("-------------------------------------------");
    char msg[64];
    sprintf(msg, "Log session begins on %d.%d.%d at %d:%d:%d\n", time.wDay, time.wMonth, time.wYear,
                                                                 time.wHour, time.wMinute, time.wSecond);    
    Log(msg);

#ifdef _DEBUG
	Log("DEBUG build");
#else
	Log("RELEASE build");
#endif
}

void Utils::LogClose()
{
    SYSTEMTIME time;
    GetLocalTime(&time);

    char msg[64];
    sprintf(msg, "\nLog session ends on %d.%d.%d at %d:%d:%d", time.wDay, time.wMonth, time.wYear,
                                                                 time.wHour, time.wMinute, time.wSecond);    
    Log(msg);
    Log("-------------------------------------------");

    fclose(m_pfileLog);
}

void Utils::Log(std::string msg)
{
    msg += "\n";
    fprintf(m_pfileLog, msg.c_str());

#ifdef _DEBUG
    fflush(m_pfileLog);  // flush stream so crashing doesn't prevent log from being saved
#endif

}



Utils::Utils()
{
    LogOpen();
}

Utils::~Utils()
{
    LogClose();
}

std::string Utils::GetFullPath(std::string _filename)
{
	char szPath[128];
	GetModuleFileName(NULL, szPath, 128);
	char * pChar = &szPath[strlen(szPath)];
	while (*pChar != '\\') pChar--;
	pChar++;
	strcpy(pChar, _filename.c_str());

	return std::string(szPath);
}
