#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



// helper makros & inlines
inline DWORD FtoDW( FLOAT f )          { return *((DWORD*)&f); }
#define SAFE_DELETE(p)        { if(p) { delete p;     p=NULL; } }
#define SAFE_DELETE_ARRAY(p)  { if(p) { delete[] p;   p=NULL; } }
#define SAFE_RELEASE(p)       { if(p) { p->Release(); p=NULL; } }

// custom assert
#ifdef _DEBUG

extern bool AssertFun(int, char*, int, char*, bool*);

#define assert(exp) \
{ static bool ignoreAll = false; \
    if (!ignoreAll) { \
        if (AssertFun((int)(exp), #exp, __LINE__, __FILE__, &ignoreAll) ) \
            { _asm { int 3 } } \
    } \
}

#else
#define assert(exp)
#endif



extern HINSTANCE g_hInstance;
extern HWND g_hWnd;
extern class CD3DFont* g_pD3DFont;



class InitException
{
public:
    std::string m_strErrorMsg;

    InitException()
    {
        m_strErrorMsg = "No Message specified";
    }

    InitException(HRESULT hres, std::string msg)
    {
        char szD3DErrorString[64];
        D3DXGetErrorString(hres, szD3DErrorString, 64); 

        m_strErrorMsg = msg + "\nD3D says: " + szD3DErrorString;
    } 
    
    InitException(std::string msg)
    {
        m_strErrorMsg = msg;
    }
};


